<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: kikimr/public/api/protos/ydb_cms.proto

namespace Ydb\Cms;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Change resources allocated for database.
 *
 * Generated from protobuf message <code>Ydb.Cms.AlterDatabaseRequest</code>
 */
class AlterDatabaseRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Full path to database's home dir.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     */
    protected $path = '';
    /**
     * Additional computational units to allocate for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.ComputationalUnits computational_units_to_add = 2;</code>
     */
    private $computational_units_to_add;
    /**
     * Computational units to deallocate.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.ComputationalUnits computational_units_to_remove = 3;</code>
     */
    private $computational_units_to_remove;
    /**
     * Additional storage units to allocate for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.StorageUnits storage_units_to_add = 4;</code>
     */
    private $storage_units_to_add;
    /**
     * Externally allocated computational units to register for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.AllocatedComputationalUnit computational_units_to_register = 5;</code>
     */
    private $computational_units_to_register;
    /**
     * Externally allocated computational units to deregister.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.AllocatedComputationalUnit computational_units_to_deregister = 6;</code>
     */
    private $computational_units_to_deregister;
    /**
     * Operation parameters.
     *
     * Generated from protobuf field <code>.Ydb.Operations.OperationParams operation_params = 7;</code>
     */
    protected $operation_params = null;
    /**
     * Current generation of altered database.
     *
     * Generated from protobuf field <code>uint64 generation = 8;</code>
     */
    protected $generation = 0;
    /**
     * Change quotas for schema operations
     *
     * Generated from protobuf field <code>.Ydb.Cms.SchemaOperationQuotas schema_operation_quotas = 9;</code>
     */
    protected $schema_operation_quotas = null;
    /**
     * Optional idempotency key
     *
     * Generated from protobuf field <code>string idempotency_key = 10;</code>
     */
    protected $idempotency_key = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $path
     *           Required. Full path to database's home dir.
     *     @type \Ydb\Cms\ComputationalUnits[]|\Google\Protobuf\Internal\RepeatedField $computational_units_to_add
     *           Additional computational units to allocate for database.
     *     @type \Ydb\Cms\ComputationalUnits[]|\Google\Protobuf\Internal\RepeatedField $computational_units_to_remove
     *           Computational units to deallocate.
     *     @type \Ydb\Cms\StorageUnits[]|\Google\Protobuf\Internal\RepeatedField $storage_units_to_add
     *           Additional storage units to allocate for database.
     *     @type \Ydb\Cms\AllocatedComputationalUnit[]|\Google\Protobuf\Internal\RepeatedField $computational_units_to_register
     *           Externally allocated computational units to register for database.
     *     @type \Ydb\Cms\AllocatedComputationalUnit[]|\Google\Protobuf\Internal\RepeatedField $computational_units_to_deregister
     *           Externally allocated computational units to deregister.
     *     @type \Ydb\Operations\OperationParams $operation_params
     *           Operation parameters.
     *     @type int|string $generation
     *           Current generation of altered database.
     *     @type \Ydb\Cms\SchemaOperationQuotas $schema_operation_quotas
     *           Change quotas for schema operations
     *     @type string $idempotency_key
     *           Optional idempotency key
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Kikimr\PBPublic\Api\Protos\YdbCms::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Full path to database's home dir.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     * @return string
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * Required. Full path to database's home dir.
     *
     * Generated from protobuf field <code>string path = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->path = $var;

        return $this;
    }

    /**
     * Additional computational units to allocate for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.ComputationalUnits computational_units_to_add = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getComputationalUnitsToAdd()
    {
        return $this->computational_units_to_add;
    }

    /**
     * Additional computational units to allocate for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.ComputationalUnits computational_units_to_add = 2;</code>
     * @param \Ydb\Cms\ComputationalUnits[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setComputationalUnitsToAdd($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Ydb\Cms\ComputationalUnits::class);
        $this->computational_units_to_add = $arr;

        return $this;
    }

    /**
     * Computational units to deallocate.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.ComputationalUnits computational_units_to_remove = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getComputationalUnitsToRemove()
    {
        return $this->computational_units_to_remove;
    }

    /**
     * Computational units to deallocate.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.ComputationalUnits computational_units_to_remove = 3;</code>
     * @param \Ydb\Cms\ComputationalUnits[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setComputationalUnitsToRemove($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Ydb\Cms\ComputationalUnits::class);
        $this->computational_units_to_remove = $arr;

        return $this;
    }

    /**
     * Additional storage units to allocate for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.StorageUnits storage_units_to_add = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getStorageUnitsToAdd()
    {
        return $this->storage_units_to_add;
    }

    /**
     * Additional storage units to allocate for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.StorageUnits storage_units_to_add = 4;</code>
     * @param \Ydb\Cms\StorageUnits[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setStorageUnitsToAdd($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Ydb\Cms\StorageUnits::class);
        $this->storage_units_to_add = $arr;

        return $this;
    }

    /**
     * Externally allocated computational units to register for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.AllocatedComputationalUnit computational_units_to_register = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getComputationalUnitsToRegister()
    {
        return $this->computational_units_to_register;
    }

    /**
     * Externally allocated computational units to register for database.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.AllocatedComputationalUnit computational_units_to_register = 5;</code>
     * @param \Ydb\Cms\AllocatedComputationalUnit[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setComputationalUnitsToRegister($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Ydb\Cms\AllocatedComputationalUnit::class);
        $this->computational_units_to_register = $arr;

        return $this;
    }

    /**
     * Externally allocated computational units to deregister.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.AllocatedComputationalUnit computational_units_to_deregister = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getComputationalUnitsToDeregister()
    {
        return $this->computational_units_to_deregister;
    }

    /**
     * Externally allocated computational units to deregister.
     *
     * Generated from protobuf field <code>repeated .Ydb.Cms.AllocatedComputationalUnit computational_units_to_deregister = 6;</code>
     * @param \Ydb\Cms\AllocatedComputationalUnit[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setComputationalUnitsToDeregister($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Ydb\Cms\AllocatedComputationalUnit::class);
        $this->computational_units_to_deregister = $arr;

        return $this;
    }

    /**
     * Operation parameters.
     *
     * Generated from protobuf field <code>.Ydb.Operations.OperationParams operation_params = 7;</code>
     * @return \Ydb\Operations\OperationParams
     */
    public function getOperationParams()
    {
        return isset($this->operation_params) ? $this->operation_params : null;
    }

    public function hasOperationParams()
    {
        return isset($this->operation_params);
    }

    public function clearOperationParams()
    {
        unset($this->operation_params);
    }

    /**
     * Operation parameters.
     *
     * Generated from protobuf field <code>.Ydb.Operations.OperationParams operation_params = 7;</code>
     * @param \Ydb\Operations\OperationParams $var
     * @return $this
     */
    public function setOperationParams($var)
    {
        GPBUtil::checkMessage($var, \Ydb\Operations\OperationParams::class);
        $this->operation_params = $var;

        return $this;
    }

    /**
     * Current generation of altered database.
     *
     * Generated from protobuf field <code>uint64 generation = 8;</code>
     * @return int|string
     */
    public function getGeneration()
    {
        return $this->generation;
    }

    /**
     * Current generation of altered database.
     *
     * Generated from protobuf field <code>uint64 generation = 8;</code>
     * @param int|string $var
     * @return $this
     */
    public function setGeneration($var)
    {
        GPBUtil::checkUint64($var);
        $this->generation = $var;

        return $this;
    }

    /**
     * Change quotas for schema operations
     *
     * Generated from protobuf field <code>.Ydb.Cms.SchemaOperationQuotas schema_operation_quotas = 9;</code>
     * @return \Ydb\Cms\SchemaOperationQuotas
     */
    public function getSchemaOperationQuotas()
    {
        return isset($this->schema_operation_quotas) ? $this->schema_operation_quotas : null;
    }

    public function hasSchemaOperationQuotas()
    {
        return isset($this->schema_operation_quotas);
    }

    public function clearSchemaOperationQuotas()
    {
        unset($this->schema_operation_quotas);
    }

    /**
     * Change quotas for schema operations
     *
     * Generated from protobuf field <code>.Ydb.Cms.SchemaOperationQuotas schema_operation_quotas = 9;</code>
     * @param \Ydb\Cms\SchemaOperationQuotas $var
     * @return $this
     */
    public function setSchemaOperationQuotas($var)
    {
        GPBUtil::checkMessage($var, \Ydb\Cms\SchemaOperationQuotas::class);
        $this->schema_operation_quotas = $var;

        return $this;
    }

    /**
     * Optional idempotency key
     *
     * Generated from protobuf field <code>string idempotency_key = 10;</code>
     * @return string
     */
    public function getIdempotencyKey()
    {
        return $this->idempotency_key;
    }

    /**
     * Optional idempotency key
     *
     * Generated from protobuf field <code>string idempotency_key = 10;</code>
     * @param string $var
     * @return $this
     */
    public function setIdempotencyKey($var)
    {
        GPBUtil::checkString($var, True);
        $this->idempotency_key = $var;

        return $this;
    }

}

