<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: kikimr/public/api/protos/ydb_persqueue_v1.proto

namespace Ydb\PersQueue\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generated from protobuf message <code>Ydb.PersQueue.V1.TopicSettings</code>
 */
class TopicSettings extends \Google\Protobuf\Internal\Message
{
    /**
     * How many partitions in topic. Must less than database limit. Default limit - 10.
     *
     * Generated from protobuf field <code>int32 partitions_count = 1 [(.Ydb.value) = "> 0"];</code>
     */
    protected $partitions_count = 0;
    /**
     * How long data in partition should be stored. Must be greater than 0 and less than limit for this database.  Default limit - 36 hours.
     *
     * Generated from protobuf field <code>int64 retention_period_ms = 2 [(.Ydb.value) = "> 0"];</code>
     */
    protected $retention_period_ms = 0;
    /**
     * How long last written seqno for message group should be stored. Must be greater then retention_period_ms and less then limit for this database.  Default limit - 16 days.
     *
     * Generated from protobuf field <code>int64 message_group_seqno_retention_period_ms = 12 [(.Ydb.value) = ">= 0"];</code>
     */
    protected $message_group_seqno_retention_period_ms = 0;
    /**
     * How many last written seqno for various message groups should be stored per partition. Must be less than limit for this database.  Default limit - 6*10^6 values.
     *
     * Generated from protobuf field <code>int64 max_partition_message_groups_seqno_stored = 13 [(.Ydb.value) = ">= 0"];</code>
     */
    protected $max_partition_message_groups_seqno_stored = 0;
    /**
     * Max format version that is allowed for writers. Must be value from enum FormatVersion.
     * Writes with greater format version are forbiden.
     *
     * Generated from protobuf field <code>.Ydb.PersQueue.V1.TopicSettings.Format supported_format = 3;</code>
     */
    protected $supported_format = 0;
    /**
     * List of allowed codecs for writers.
     * Writes with codec not from this list are forbiden.
     *
     * Generated from protobuf field <code>repeated .Ydb.PersQueue.V1.Codec supported_codecs = 4 [(.Ydb.size) = {</code>
     */
    private $supported_codecs;
    /**
     * Max storage usage for each topic's partition. Must be less than database limit. Default limit - 130 GB.
     *
     * Generated from protobuf field <code>int64 max_partition_storage_size = 5 [(.Ydb.value) = ">= 0"];</code>
     */
    protected $max_partition_storage_size = 0;
    /**
     * Partition write speed in bytes per second. Must be less than database limit. Default limit - 1 MB/s.
     *
     * Generated from protobuf field <code>int64 max_partition_write_speed = 6 [(.Ydb.value) = ">= 0"];</code>
     */
    protected $max_partition_write_speed = 0;
    /**
     * Burst size for write in partition, in bytes. Must be less than database limit. Default limit - 1 MB.
     *
     * Generated from protobuf field <code>int64 max_partition_write_burst = 7 [(.Ydb.value) = ">= 0"];</code>
     */
    protected $max_partition_write_burst = 0;
    /**
     * Disallows client writes. Used for mirrored topics in federation.
     *
     * Generated from protobuf field <code>bool client_write_disabled = 8;</code>
     */
    protected $client_write_disabled = false;
    /**
     * List of consumer read rules for this topic.
     *
     * Generated from protobuf field <code>repeated .Ydb.PersQueue.V1.TopicSettings.ReadRule read_rules = 9 [(.Ydb.size) = {</code>
     */
    private $read_rules;
    /**
     * User and server attributes of topic. Server attributes starts from "_" and will be validated by server.
     *
     * Generated from protobuf field <code>map<string, string> attributes = 10;</code>
     */
    private $attributes;
    /**
     * remote mirror rule for this topic.
     *
     * Generated from protobuf field <code>.Ydb.PersQueue.V1.TopicSettings.RemoteMirrorRule remote_mirror_rule = 11;</code>
     */
    protected $remote_mirror_rule = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $partitions_count
     *           How many partitions in topic. Must less than database limit. Default limit - 10.
     *     @type int|string $retention_period_ms
     *           How long data in partition should be stored. Must be greater than 0 and less than limit for this database.  Default limit - 36 hours.
     *     @type int|string $message_group_seqno_retention_period_ms
     *           How long last written seqno for message group should be stored. Must be greater then retention_period_ms and less then limit for this database.  Default limit - 16 days.
     *     @type int|string $max_partition_message_groups_seqno_stored
     *           How many last written seqno for various message groups should be stored per partition. Must be less than limit for this database.  Default limit - 6*10^6 values.
     *     @type int $supported_format
     *           Max format version that is allowed for writers. Must be value from enum FormatVersion.
     *           Writes with greater format version are forbiden.
     *     @type int[]|\Google\Protobuf\Internal\RepeatedField $supported_codecs
     *           List of allowed codecs for writers.
     *           Writes with codec not from this list are forbiden.
     *     @type int|string $max_partition_storage_size
     *           Max storage usage for each topic's partition. Must be less than database limit. Default limit - 130 GB.
     *     @type int|string $max_partition_write_speed
     *           Partition write speed in bytes per second. Must be less than database limit. Default limit - 1 MB/s.
     *     @type int|string $max_partition_write_burst
     *           Burst size for write in partition, in bytes. Must be less than database limit. Default limit - 1 MB.
     *     @type bool $client_write_disabled
     *           Disallows client writes. Used for mirrored topics in federation.
     *     @type \Ydb\PersQueue\V1\TopicSettings\ReadRule[]|\Google\Protobuf\Internal\RepeatedField $read_rules
     *           List of consumer read rules for this topic.
     *     @type array|\Google\Protobuf\Internal\MapField $attributes
     *           User and server attributes of topic. Server attributes starts from "_" and will be validated by server.
     *     @type \Ydb\PersQueue\V1\TopicSettings\RemoteMirrorRule $remote_mirror_rule
     *           remote mirror rule for this topic.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Kikimr\PBPublic\Api\Protos\YdbPersqueueV1::initOnce();
        parent::__construct($data);
    }

    /**
     * How many partitions in topic. Must less than database limit. Default limit - 10.
     *
     * Generated from protobuf field <code>int32 partitions_count = 1 [(.Ydb.value) = "> 0"];</code>
     * @return int
     */
    public function getPartitionsCount()
    {
        return $this->partitions_count;
    }

    /**
     * How many partitions in topic. Must less than database limit. Default limit - 10.
     *
     * Generated from protobuf field <code>int32 partitions_count = 1 [(.Ydb.value) = "> 0"];</code>
     * @param int $var
     * @return $this
     */
    public function setPartitionsCount($var)
    {
        GPBUtil::checkInt32($var);
        $this->partitions_count = $var;

        return $this;
    }

    /**
     * How long data in partition should be stored. Must be greater than 0 and less than limit for this database.  Default limit - 36 hours.
     *
     * Generated from protobuf field <code>int64 retention_period_ms = 2 [(.Ydb.value) = "> 0"];</code>
     * @return int|string
     */
    public function getRetentionPeriodMs()
    {
        return $this->retention_period_ms;
    }

    /**
     * How long data in partition should be stored. Must be greater than 0 and less than limit for this database.  Default limit - 36 hours.
     *
     * Generated from protobuf field <code>int64 retention_period_ms = 2 [(.Ydb.value) = "> 0"];</code>
     * @param int|string $var
     * @return $this
     */
    public function setRetentionPeriodMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->retention_period_ms = $var;

        return $this;
    }

    /**
     * How long last written seqno for message group should be stored. Must be greater then retention_period_ms and less then limit for this database.  Default limit - 16 days.
     *
     * Generated from protobuf field <code>int64 message_group_seqno_retention_period_ms = 12 [(.Ydb.value) = ">= 0"];</code>
     * @return int|string
     */
    public function getMessageGroupSeqnoRetentionPeriodMs()
    {
        return $this->message_group_seqno_retention_period_ms;
    }

    /**
     * How long last written seqno for message group should be stored. Must be greater then retention_period_ms and less then limit for this database.  Default limit - 16 days.
     *
     * Generated from protobuf field <code>int64 message_group_seqno_retention_period_ms = 12 [(.Ydb.value) = ">= 0"];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMessageGroupSeqnoRetentionPeriodMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->message_group_seqno_retention_period_ms = $var;

        return $this;
    }

    /**
     * How many last written seqno for various message groups should be stored per partition. Must be less than limit for this database.  Default limit - 6*10^6 values.
     *
     * Generated from protobuf field <code>int64 max_partition_message_groups_seqno_stored = 13 [(.Ydb.value) = ">= 0"];</code>
     * @return int|string
     */
    public function getMaxPartitionMessageGroupsSeqnoStored()
    {
        return $this->max_partition_message_groups_seqno_stored;
    }

    /**
     * How many last written seqno for various message groups should be stored per partition. Must be less than limit for this database.  Default limit - 6*10^6 values.
     *
     * Generated from protobuf field <code>int64 max_partition_message_groups_seqno_stored = 13 [(.Ydb.value) = ">= 0"];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxPartitionMessageGroupsSeqnoStored($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_partition_message_groups_seqno_stored = $var;

        return $this;
    }

    /**
     * Max format version that is allowed for writers. Must be value from enum FormatVersion.
     * Writes with greater format version are forbiden.
     *
     * Generated from protobuf field <code>.Ydb.PersQueue.V1.TopicSettings.Format supported_format = 3;</code>
     * @return int
     */
    public function getSupportedFormat()
    {
        return $this->supported_format;
    }

    /**
     * Max format version that is allowed for writers. Must be value from enum FormatVersion.
     * Writes with greater format version are forbiden.
     *
     * Generated from protobuf field <code>.Ydb.PersQueue.V1.TopicSettings.Format supported_format = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setSupportedFormat($var)
    {
        GPBUtil::checkEnum($var, \Ydb\PersQueue\V1\TopicSettings\Format::class);
        $this->supported_format = $var;

        return $this;
    }

    /**
     * List of allowed codecs for writers.
     * Writes with codec not from this list are forbiden.
     *
     * Generated from protobuf field <code>repeated .Ydb.PersQueue.V1.Codec supported_codecs = 4 [(.Ydb.size) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSupportedCodecs()
    {
        return $this->supported_codecs;
    }

    /**
     * List of allowed codecs for writers.
     * Writes with codec not from this list are forbiden.
     *
     * Generated from protobuf field <code>repeated .Ydb.PersQueue.V1.Codec supported_codecs = 4 [(.Ydb.size) = {</code>
     * @param int[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSupportedCodecs($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::ENUM, \Ydb\PersQueue\V1\Codec::class);
        $this->supported_codecs = $arr;

        return $this;
    }

    /**
     * Max storage usage for each topic's partition. Must be less than database limit. Default limit - 130 GB.
     *
     * Generated from protobuf field <code>int64 max_partition_storage_size = 5 [(.Ydb.value) = ">= 0"];</code>
     * @return int|string
     */
    public function getMaxPartitionStorageSize()
    {
        return $this->max_partition_storage_size;
    }

    /**
     * Max storage usage for each topic's partition. Must be less than database limit. Default limit - 130 GB.
     *
     * Generated from protobuf field <code>int64 max_partition_storage_size = 5 [(.Ydb.value) = ">= 0"];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxPartitionStorageSize($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_partition_storage_size = $var;

        return $this;
    }

    /**
     * Partition write speed in bytes per second. Must be less than database limit. Default limit - 1 MB/s.
     *
     * Generated from protobuf field <code>int64 max_partition_write_speed = 6 [(.Ydb.value) = ">= 0"];</code>
     * @return int|string
     */
    public function getMaxPartitionWriteSpeed()
    {
        return $this->max_partition_write_speed;
    }

    /**
     * Partition write speed in bytes per second. Must be less than database limit. Default limit - 1 MB/s.
     *
     * Generated from protobuf field <code>int64 max_partition_write_speed = 6 [(.Ydb.value) = ">= 0"];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxPartitionWriteSpeed($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_partition_write_speed = $var;

        return $this;
    }

    /**
     * Burst size for write in partition, in bytes. Must be less than database limit. Default limit - 1 MB.
     *
     * Generated from protobuf field <code>int64 max_partition_write_burst = 7 [(.Ydb.value) = ">= 0"];</code>
     * @return int|string
     */
    public function getMaxPartitionWriteBurst()
    {
        return $this->max_partition_write_burst;
    }

    /**
     * Burst size for write in partition, in bytes. Must be less than database limit. Default limit - 1 MB.
     *
     * Generated from protobuf field <code>int64 max_partition_write_burst = 7 [(.Ydb.value) = ">= 0"];</code>
     * @param int|string $var
     * @return $this
     */
    public function setMaxPartitionWriteBurst($var)
    {
        GPBUtil::checkInt64($var);
        $this->max_partition_write_burst = $var;

        return $this;
    }

    /**
     * Disallows client writes. Used for mirrored topics in federation.
     *
     * Generated from protobuf field <code>bool client_write_disabled = 8;</code>
     * @return bool
     */
    public function getClientWriteDisabled()
    {
        return $this->client_write_disabled;
    }

    /**
     * Disallows client writes. Used for mirrored topics in federation.
     *
     * Generated from protobuf field <code>bool client_write_disabled = 8;</code>
     * @param bool $var
     * @return $this
     */
    public function setClientWriteDisabled($var)
    {
        GPBUtil::checkBool($var);
        $this->client_write_disabled = $var;

        return $this;
    }

    /**
     * List of consumer read rules for this topic.
     *
     * Generated from protobuf field <code>repeated .Ydb.PersQueue.V1.TopicSettings.ReadRule read_rules = 9 [(.Ydb.size) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getReadRules()
    {
        return $this->read_rules;
    }

    /**
     * List of consumer read rules for this topic.
     *
     * Generated from protobuf field <code>repeated .Ydb.PersQueue.V1.TopicSettings.ReadRule read_rules = 9 [(.Ydb.size) = {</code>
     * @param \Ydb\PersQueue\V1\TopicSettings\ReadRule[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setReadRules($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Ydb\PersQueue\V1\TopicSettings\ReadRule::class);
        $this->read_rules = $arr;

        return $this;
    }

    /**
     * User and server attributes of topic. Server attributes starts from "_" and will be validated by server.
     *
     * Generated from protobuf field <code>map<string, string> attributes = 10;</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    /**
     * User and server attributes of topic. Server attributes starts from "_" and will be validated by server.
     *
     * Generated from protobuf field <code>map<string, string> attributes = 10;</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setAttributes($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->attributes = $arr;

        return $this;
    }

    /**
     * remote mirror rule for this topic.
     *
     * Generated from protobuf field <code>.Ydb.PersQueue.V1.TopicSettings.RemoteMirrorRule remote_mirror_rule = 11;</code>
     * @return \Ydb\PersQueue\V1\TopicSettings\RemoteMirrorRule
     */
    public function getRemoteMirrorRule()
    {
        return isset($this->remote_mirror_rule) ? $this->remote_mirror_rule : null;
    }

    public function hasRemoteMirrorRule()
    {
        return isset($this->remote_mirror_rule);
    }

    public function clearRemoteMirrorRule()
    {
        unset($this->remote_mirror_rule);
    }

    /**
     * remote mirror rule for this topic.
     *
     * Generated from protobuf field <code>.Ydb.PersQueue.V1.TopicSettings.RemoteMirrorRule remote_mirror_rule = 11;</code>
     * @param \Ydb\PersQueue\V1\TopicSettings\RemoteMirrorRule $var
     * @return $this
     */
    public function setRemoteMirrorRule($var)
    {
        GPBUtil::checkMessage($var, \Ydb\PersQueue\V1\TopicSettings\RemoteMirrorRule::class);
        $this->remote_mirror_rule = $var;

        return $this;
    }

}

